org.apache.poi.util

## Annotation Type Removal

-     @Documented
       @Retention(value=RUNTIME)
      public @interface Removal

  Program elements annotated @Removal track the earliest final release when a deprecated feature will be removed. This is an internal decoration: a feature may be removed in a release earlier or later than the release number specified by this annotation.

  The POI project policy is to deprecate an element for 2 final releases before removing. This annotation exists to make it easier to follow up on the second step of the two-step deprecate and remove process.

  A deprecated feature may be removed in nightly and beta releases prior to the final release for which it is eligible, but may be removed later for various reasons. If it is known in advance that the feature will not be removed in the n+2 release, a later version should be specified by this annotation. The annotation version number should not include beta

  For example, a feature with a `@deprecated POI 3.15 beta 3` is deprecated in POI 3.15 and 3.16 and becomes eligible for deletion during the POI 3.17 release series, and may be deleted immediately after POI 3.16 is released. This would be annotated `@Removal(version="3.17")`

  .
  Since:
    POI-3.15 beta 3

- - ### Optional Element Summary

    Optional Elements
    Modifier and Type | Optional Element and Description
    --- | ---
    `java.lang.String` | `version` The POI version when this feature may be removed.

- - ### Element Detail

    - #### version

          public abstract java.lang.String version

      The POI version when this feature may be removed. To ensure that the version number can be compared to the current version and a unit test can generate a warning if a removal-eligible feature has not been removed yet, the version number should adhere to the following format: Format: "(?\d+)\.(?\d+)" Example: "3.15"
      Default:
        ""

Copyright 2020 The Apache Software Foundation or its licensors, as applicable.